;;; -*- Mode: Lisp; Package: User; Base: 8.; Patch-File: T -*-
;;; Patch file for System version 78.33
;;; Reason: si:system-source-files to return defsystem file (-mmcm).
;;; Written 12/24/81 11:35:10 by BSG,
;;; while running on Beagle from band 3
;;; with System 78.32, ZMail 38.5, Symbolics 8.7, Tape 6.4, LMFS 21.18, Canon 9.5, microcode 840.



; From file MAKSYS.LISP >LISPM2 POINTER:
#8R SYSTEM-INTERNALS:(COMPILER-LET ((PACKAGE (PKG-FIND-PACKAGE "SYSTEM-INTERNALS")))

(DEFUN SYSTEM-SOURCE-FILES-1 (SYSTEM TYPES)
  (SETQ SYSTEM (FIND-SYSTEM-NAMED SYSTEM))
  (NCONC (LET ((SYMBOL (SYSTEM-SYMBOLIC-NAME SYSTEM)))
	   (AND SYMBOL
		(LET ((FILE (GET-SOURCE-FILE-NAME SYMBOL 'DEFSYSTEM)))
		  (AND FILE
		       (LET ((DEFINING-SYSTEM (FUNCALL FILE ':GET 'MAYBE-RELOAD-SYSTEM)))
			 (AND DEFINING-SYSTEM
			      (SYSTEM-SOURCE-FILES-1 DEFINING-SYSTEM TYPES)))))))
	 (LOOP FOR SUBSYS IN (SYSTEM-COMPONENT-SYSTEMS SYSTEM)
	       NCONC (SYSTEM-SOURCE-FILES-1 SUBSYS TYPES))
	 (LET ((*FORCE-PACKAGE* (SYSTEM-PACKAGE-DEFAULT SYSTEM)))
	   (LOOP FOR TRANSFORMATION IN (SYSTEM-TRANSFORMATIONS SYSTEM)
		 AS INPUT = (TRANSFORMATION-INPUT TRANSFORMATION)
		 AND FILE-TYPES = (TRANSFORMATION-TYPE-INPUT-FILE-TYPES
				    (TRANSFORMATION-TRANSFORMATION-TYPE TRANSFORMATION))
		 WHEN (TYPEP INPUT 'MODULE)
		      NCONC (LOOP FOR PATHNAMES IN (GET-MODULE-PATHNAMES INPUT NIL)
				  NCONC (LOOP FOR FILE-TYPE IN FILE-TYPES
					      AND PATHNAME IN (CDR PATHNAMES)
					      WHEN (OR (EQ TYPES ':ALL)
						       (MEMBER FILE-TYPE TYPES))
						    COLLECT (MERGE-PATHNAME-TYPE PATHNAME
										 FILE-TYPE))))
	   )))

)
